'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var transformParamsToString = function transformParamsToString(params) {
    return transformObjectToString(params).slice(1, -1);
};

var transformElementToString = function transformElementToString(element) {
    if (Array.isArray(element)) {
        return transformArrayToString(element);
    } else if ((typeof element === 'undefined' ? 'undefined' : _typeof(element)) === 'object') {
        return transformObjectToString(element);
    } else if (typeof element === 'string') {
        return transformStringToString(element);
    } else {
        return element;
    }
};

var transformObjectToString = function transformObjectToString(object) {
    var str = '';
    for (var key in object) {
        str += key + ':' + transformElementToString(object[key]) + ',';
    }
    return '{' + (str ? str.substring(0, str.length - 1) : '') + '}';
};

var transformArrayToString = function transformArrayToString(array) {
    var str = '';
    array.forEach(function (element) {
        str += transformElementToString(element) + ',';
    });
    return '[' + (str ? str.substring(0, str.length - 1) : '') + ']';
};

var transformStringToString = function transformStringToString(string) {
    return '"' + string + '"';
};

exports.default = transformParamsToString;