'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('whatwg-fetch');

var createFetcher = function createFetcher(path) {
    return function (request) {
        return fetch(path, {
            method: 'POST',
            headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json'
            },
            credentials: 'include',
            body: JSON.stringify({
                query: request
            })
        }).then(function (response) {
            try {
                return response.json();
            } catch (e) {
                if (DEVELOPMENT) {
                    console.log(e);
                }
                throw new JsonParsingError("graphl response is not a valid json object");
            }
        });
    };
};

var JsonParsingError = function JsonParsingError(message) {
    _classCallCheck(this, JsonParsingError);

    this.name = "JsonParsingError";
    this.message = message || "";
};

exports.default = createFetcher;