import 'whatwg-fetch'

const createFetcher = path => request =>
    fetch(path, {
        method: 'POST',
        headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
        },
        credentials: 'include',
        body: JSON.stringify({
            query: request
        })
    })
    .then(response => {
        try {
            return response.json()
        } catch(e) {
            if(DEVELOPMENT) {
                console.log(e)
            }
            throw new JsonParsingError("graphl response is not a valid json object")
        }
    })

class JsonParsingError {
    constructor(message) {
        this.name = "JsonParsingError";
        this.message = (message || "");
    }
}
export default createFetcher;
