import createFetcher from './createFetcher.js';

const createGraphqlGate = (path) => {
    const fetcher = createFetcher(path);
    return action =>
        action.type === 'batch' ? processBatch(fetcher, action) : processAction(fetcher, action);
};

const processBatch = (fetcher, batch) =>
    batch.actions

const processAction = (fetcher, action) => {
    if (action.payload.type === 'mutation') {
        return processMutation(fetcher, action.payload);
    } else if (action.payload.type === 'query') {
        return processQuery(fetcher, action.payload);
    }
}

const processMutation = (fetcher, mutation) =>
    fetcher(`mutation { ${mutation.name}(${mutation.params})${mutation.query} }`)

const processQuery = (fetcher, query) =>
    fetcher(`query { ${query.name}(${query.params})${query.query} }`)

export default createGraphqlGate;
