const transformParamsToString = params =>
    transformObjectToString(params).slice(1, -1);

const transformElementToString = element => {
    if (Array.isArray(element)) {
        return transformArrayToString(element);
    } else if (typeof element === 'object') {
        return transformObjectToString(element);
    } else if (typeof element === 'string') {
        return transformStringToString(element);
    } else {
        return element
    }
}

const transformObjectToString = object => {
    let str = '';
    for (const key in object) {
        str += `${key}:${transformElementToString(object[key])},`
    }
    return `{${str? str.substring(0, str.length - 1) : ''}}`;
}

const transformArrayToString = array => {
    let str = '';
    array.forEach(element => {
        str += `${transformElementToString(element)},`
    })
    return `[${str? str.substring(0, str.length - 1) : ''}]`;
}

const transformStringToString = string => `"${string}"`

export default transformParamsToString;
